package com.qmth.themis.business.enums;

import java.util.Objects;

/**
 * @Description: 任务类型
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2020/7/15
 */
public enum TaskTypeEnum {

    /**
     * 考试重新算分
     */
    calculate_exam_score(0),

    /**
     * 导入考生
     */
    import_exam_student(1),

    /**
     * 导入试卷
     */
    import_exam_paper(2),

    /**
     * 导入监考员
     */
    import_invigilate_user(3),

    /**
     * 导出监考员
     */
    export_invigilate_user(4);

    private int id;

    private TaskTypeEnum(int id) {
        this.id = id;
    }

    public int getId() {
        return id;
    }

    /**
     * 状态转换 toId
     *
     * @param value
     * @return
     */
    public static int convertToId(String value) {
        if (Objects.equals(value.trim(), calculate_exam_score.name())) {
            return calculate_exam_score.getId();
        } else if (Objects.equals(value.trim(), import_exam_student.name())) {
            return import_exam_student.getId();
        } else if (Objects.equals(value.trim(), import_exam_paper.name())) {
            return import_exam_paper.getId();
        } else if (Objects.equals(value.trim(), import_invigilate_user.name())) {
            return import_invigilate_user.getId();
        } else {
            return export_invigilate_user.getId();
        }
    }

    /**
     * 状态转换 toName
     *
     * @param value
     * @return
     */
    public static String convertToName(int value) {
        if (value == calculate_exam_score.getId()) {
            return calculate_exam_score.name();
        } else if (value == import_exam_student.getId()) {
            return import_exam_student.name();
        } else if (value == import_exam_paper.getId()) {
            return import_exam_paper.name();
        } else if (value == import_invigilate_user.getId()) {
            return import_invigilate_user.name();
        } else {
            return export_invigilate_user.name();
        }
    }
}
